MWAWPictBitmapColor Class Reference documentation

MWAWPictBitmapColor Class Referencefinal

a bitmap of MWAWColor to store true color bitmap More...

`#include <MWAWPictBitmap.hxx>`

Inheritance diagram for MWAWPictBitmapColor:

## Public Member Functions
SubType | getSubType () const final
| return the picture subtype
int | cmp (MWAWPict const &a) const final
| a virtual function used to obtain a strict order, must be redefined in the subs class
bool | valid () const final
| returns true if the picture is valid
MWAWColor | getAverageColor () const final
| returns the average color
| MWAWPictBitmapColor (MWAWVec2i const &sz, bool useAlphaChannel=false)
| the constructor
MWAWVec2i const & | size () const
| the picture size
int | numRows () const
| the number of rows
int | numColumns () const
| the number of columns
MWAWColor | get (int i, int j) const
| returns a cell content
MWAWColor const * | getRow (int j) const
| returns the cells content of a row
void | set (int i, int j, MWAWColor const &v)
| sets a cell contents
void | setRow (int j, MWAWColor const *val)
| sets all cell contents of a row
void | setColumn (int i, MWAWColor const *val)
| sets all cell contents of a column
Public Member Functions inherited from MWAWPictBitmap
| ~MWAWPictBitmap () override
| destructor
Type | getType () const override
| returns the picture type
bool | getBinary (MWAWEmbeddedObject &picture) const override
| returns the final picture
Public Member Functions inherited from MWAWPict
virtual | ~MWAWPict ()
| virtual destructor
MWAWBox2f | getBdBox () const
| returns the bdbox of the picture
void | setBdBox (MWAWBox2f const &box)
| sets the bdbox of the picture

## Protected Member Functions
bool | createFileData (librevenge::RVNGBinaryData &result) const final
| the function which creates the result file
Protected Member Functions inherited from MWAWPictBitmap
| MWAWPictBitmap (MWAWVec2i const &sz)
| protected constructor: use check to construct a picture
Protected Member Functions inherited from MWAWPict
void | extendBDBox (float val)
| udaptes the bdbox, by extended it by (val-previousVal)
| MWAWPict ()
| protected constructor must not be called directly
| MWAWPict (MWAWPict const &p)
| protected constructor must not be called directly
MWAWPict & | operator= (MWAWPict const &p)
| protected operator= must not be called directly

## Protected Attributes
MWAWPictBitmapContainer< MWAWColor > | m_data
| the data
bool | m_hasAlpha
| true if the bitmap has alpha color

## Additional Inherited Members
Public Types inherited from MWAWPictBitmap
enum | SubType { BW , Indexed , Color }
| the picture subtype: blackwhite, indexed, color More...
Public Types inherited from MWAWPict
enum | Type { PictData , Bitmap , Unknown }
| the different picture types: More...
enum | ReadResult { MWAW_R_BAD =0 , MWAW_R_OK , MWAW_R_OK_EMPTY , MWAW_R_MAYBE }
| an enum to defined the result of a parsing use by some picture's classes which can read their data More...
Static Protected Member Functions inherited from MWAWPict
static MWAWBox2f | getBdBox (int numPt, MWAWVec2f const *pt)
| computes the minimum and maximum of a list of point

## Detailed Description

a bitmap of MWAWColor to store true color bitmap

Note
  : this class is actually the only class which can create bitmap with transparency (by creating a BMP), but as LibreOffice/OpenOffice seem to ignore the alpha channel when importing BMP pictures...

## Constructor & Destructor Documentation

## ◆ MWAWPictBitmapColor()

MWAWPictBitmapColor::MWAWPictBitmapColor | ( | MWAWVec2i const & | sz,
|  | bool | useAlphaChannel = false )
| inline

the constructor

Referenced by cmp(), and MWAWPictBitmapColor().

## Member Function Documentation

## ◆ cmp()

int MWAWPictBitmapColor::cmp | ( | MWAWPict const & | a | ) | const
| inlinefinalvirtual

a virtual function used to obtain a strict order, must be redefined in the subs class

Reimplemented from MWAWPictBitmap.

## ◆ createFileData()

bool MWAWPictBitmapColor::createFileData | ( | librevenge::RVNGBinaryData & | result | ) | const
| finalprotectedvirtual

the function which creates the result file

Implements MWAWPictBitmap.

## ◆ get()

MWAWColor MWAWPictBitmapColor::get | ( | int | i,
|  | int | j ) const
| inline

returns a cell content

## ◆ getAverageColor()

MWAWColor MWAWPictBitmapColor::getAverageColor | ( |  | ) | const
| finalvirtual

returns the average color

Implements MWAWPictBitmap.

## ◆ getRow()

MWAWColor const * MWAWPictBitmapColor::getRow | ( | int | j | ) | const
| inline

returns the cells content of a row

Referenced by getAverageColor().

## ◆ getSubType()

SubType MWAWPictBitmapColor::getSubType | ( |  | ) | const
| inlinefinalvirtual

return the picture subtype

Implements MWAWPictBitmap.

## ◆ numColumns()

int MWAWPictBitmapColor::numColumns | ( |  | ) | const
| inline

the number of columns

## ◆ numRows()

int MWAWPictBitmapColor::numRows | ( |  | ) | const
| inline

the number of rows

## ◆ set()

void MWAWPictBitmapColor::set | ( | int | i,
|  | int | j,
|  | MWAWColor const & | v )
| inline

sets a cell contents

Referenced by ApplePictParserInternal::Pixmap::get(), MacDraft5StyleManagerInternal::Pixmap::get(), CanvasGraph::getBitmap(), Canvas5Structure::readPreview(), ClarisDrawGraph::sendBitmap(), ClarisWksGraph::sendBitmap(), and MacDraftParser::sendBitmap().

## ◆ setColumn()

void MWAWPictBitmapColor::setColumn | ( | int | i,
|  | MWAWColor const * | val )
| inline

sets all cell contents of a column

## ◆ setRow()

void MWAWPictBitmapColor::setRow | ( | int | j,
|  | MWAWColor const * | val )
| inline

sets all cell contents of a row

Referenced by CorelPainterParser::readResource(), MacDraftParser::sendBitmap(), and MacDrawParser::sendBitmap().

## ◆ size()

MWAWVec2i const & MWAWPictBitmapColor::size | ( |  | ) | const
| inline

the picture size

## ◆ valid()

bool MWAWPictBitmapColor::valid | ( |  | ) | const
| inlinefinalvirtual

returns true if the picture is valid

Reimplemented from MWAWPictBitmap.

Referenced by ApplePictParserInternal::Pixmap::get(), and MacDraft5StyleManagerInternal::Pixmap::get().

## Member Data Documentation

## ◆ m_data

MWAWPictBitmapContainer<MWAWColor> MWAWPictBitmapColor::m_data
| protected

the data

Referenced by cmp(), createFileData(), get(), getAverageColor(), getRow(), MWAWPictBitmapColor(), numColumns(), numRows(), set(), setColumn(), setRow(), size(), and valid().

## ◆ m_hasAlpha

bool MWAWPictBitmapColor::m_hasAlpha
| protected

true if the bitmap has alpha color

Referenced by createFileData(), and MWAWPictBitmapColor().

The documentation for this class was generated from the following files:

- MWAWPictBitmap.hxx
- MWAWPictBitmap.cxx